package net.ihe.gazelle.proxy.action;

import javax.persistence.EntityManager;
import javax.persistence.EntityTransaction;

import net.ihe.gazelle.proxy.listeners.MessageListener;
import net.ihe.gazelle.proxy.model.message.AbstractMessage;
import net.ihe.gazelle.proxy.util.HibernateUtilProxy;

public class MessageListenerSave implements MessageListener {

	private static org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger(MessageListenerSave.class);

	public EntityManager getEntityManager() {
		return HibernateUtilProxy.getEntityManagerFactory().createEntityManager();
	}

	public AbstractMessage processMessage(EntityManager em, AbstractMessage abstractMessage) {
		if (em == null || abstractMessage == null) {
			log.fatal("entityManager null or abstractMessage null");
			return null;
		}
		AbstractMessage messageToReturn = null;
		synchronized (em) {

			boolean transactionWasActive = false;

			EntityTransaction transaction = em.getTransaction();
			synchronized (transaction) {
				if (!transaction.isActive()) {
					transaction.begin();
				} else
					transactionWasActive = true;

				messageToReturn = em.merge(abstractMessage);

				if (!transactionWasActive) {
					transaction.commit();
				}
			}
		}
		return messageToReturn;
	}

}
