package net.ihe.gazelle.proxy.factory;

import org.jboss.netty.handler.codec.http.HttpMessage;

import net.ihe.gazelle.proxy.listeners.HttpEventListener;
import net.ihe.gazelle.proxy.netty.ChannelType;
import net.ihe.gazelle.proxy.netty.ConnectionConfig;
import net.ihe.gazelle.proxy.netty.Proxy;
import net.ihe.gazelle.proxy.netty.ProxyFactory;
import net.ihe.gazelle.proxy.netty.protocols.http.HttpProxy;
import net.ihe.gazelle.proxy.util.MessageListenerProvider;

public class HttpProxyFactory implements ProxyFactory {

	@Override
	public Proxy<?, ?> newProxy(ConnectionConfig<?, ?> connectionConfig) {
		HttpEventListener proxyEventListener = new HttpEventListener(MessageListenerProvider.getMessageListener());
		return new HttpProxy(proxyEventListener, (ConnectionConfig<HttpMessage, HttpMessage>) connectionConfig);
	}

	@Override
	public ChannelType getChannelType() {
		return ChannelType.HTTP;
	}

}
