package net.ihe.gazelle.proxy.listeners;

import net.ihe.gazelle.proxy.netty.channel.ProxySide;

public abstract class SameEventListener<T> extends GazelleProxyEventListener<T, T> {

	public SameEventListener(MessageListener messageListener) {
		super(messageListener);
	}

	protected abstract void saveMessage(T message, String requesterIp, int requesterPort, int proxyPort,
			String responderIp, int responderPort, int channelId, ProxySide side);

	public void onRequest(T request, String requesterIp, int requesterPort, int proxyPort, String responderIp,
			int responderPort, int channelId) {
		saveMessage(request, requesterIp, requesterPort, proxyPort, responderIp, responderPort, channelId,
				ProxySide.REQUEST);
	}

	public void onResponse(T response, String requesterIp, int requesterPort, int proxyPort, String responderIp,
			int responderPort, int channelId) {
		saveMessage(response, requesterIp, requesterPort, proxyPort, responderIp, responderPort, channelId,
				ProxySide.RESPONSE);
	}

}
