package net.ihe.gazelle.proxy.listeners;

import net.ihe.gazelle.proxy.model.message.SyslogMessage;
import net.ihe.gazelle.proxy.netty.channel.ProxySide;

public class SyslogEventListener extends SameEventListener<String> {

	public SyslogEventListener(MessageListener messageListener) {
		super(messageListener);
	}

	protected void saveMessage(String message, String requesterIp, int requesterPort, int proxyPort,
			String responderIp, int responderPort, int channelId, ProxySide side) {
		// Messages are coming from different threads!
		synchronized (this) {
			SyslogMessage syslogMessage = new SyslogMessage(requesterIp, requesterPort, proxyPort, responderIp,
					responderPort, channelId, side);
			syslogMessage.setMessageReceivedAsString(message);
			messageListener.processMessage(messageListener.getEntityManager(), syslogMessage);
		}
	}

}
