/*
 * Copyright 2009 IHE International (http://www.ihe.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.ihe.gazelle.proxy.netty;

import java.util.ServiceLoader;

public enum ChannelType {

	DICOM("DicomMessage"),

	HL7("HL7Message"),

	SYSLOG("SyslogMessage"),

	HTTP("HTTPMessage"),

	RAW("HTTPMessage");

	private String discriminator;

	ChannelType(String discriminator) {
		this.discriminator = discriminator;
	}

	public String getDiscriminator() {
		return discriminator;
	}

	public Proxy<?, ?> getProxy(ConnectionConfig<?, ?> connectionConfig) {
		ServiceLoader<ProxyFactory> serviceLoader = ServiceLoader.load(ProxyFactory.class);
		for (ProxyFactory proxyFactory : serviceLoader) {
			if (proxyFactory.getChannelType().equals(this)) {
				return proxyFactory.newProxy(connectionConfig);
			}
		}
		return null;
	}

}
