package net.ihe.gazelle.proxy.netty;

import java.util.List;

import org.jboss.netty.channel.ChannelHandler;

public interface ConnectionConfig<REQU, RESP> {

	// Add specific handlers when a client connects to the server proxy (mainly
	// for TLS)
	List<ChannelHandler> getRequestConnectionHandlers();

	// Add specific handlers when server proxy connects to the forwarded server
	// (mainly for TLS)
	List<ChannelHandler> getResponseConnectionHandlers();

	int getLocalPort();

	String getRemoteHost();

	int getRemotePort();

	ChannelType getChannelType();

}