package net.ihe.gazelle.proxy.netty;

import java.io.PrintStream;

public abstract class ProxyEventListenerToStream<REQU, RESP> implements ProxyEventListener<REQU, RESP> {

	private PrintStream printStream;

	public ProxyEventListenerToStream(PrintStream printStream) {
		super();
		this.printStream = printStream;
	}

	public void onRequest(REQU request, String requesterIp, int requesterPort, int proxyPort, String responderIp,
			int responderPort, int channelId) {
		synchronized (this) {
			printStream.println(channelId + " ->->->->->->->->->->->->->->->->->->->->->->->");
			printStream.println(" " + requesterIp + ":" + requesterPort + " -" + proxyPort + "> " + responderIp + ":"
					+ responderPort);
			printStream.println(channelId + " ->->->->->->->->->->->->->->->->->->->->->->->");
			printStream.println(decodeRequest(request));
			printStream.println(channelId + " ->->->->->->->->->->->->->->->->->->->->->->->");
		}
	}

	public void onResponse(RESP response, String requesterIp, int requesterPort, int proxyPort, String responderIp,
			int responderPort, int channelId) {
		synchronized (this) {
			printStream.println(channelId + " <-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-");
			printStream.println(" " + requesterIp + ":" + requesterPort + " <" + proxyPort + "- " + responderIp + ":"
					+ responderPort);
			printStream.println(channelId + " <-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-");
			printStream.println(decodeResponse(response));
			printStream.println(channelId + " <-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-<-");
		}
	}

	protected abstract String decodeResponse(RESP response);

	protected abstract String decodeRequest(REQU request);

}
