package net.ihe.gazelle.proxy.netty.basictls;

import java.util.ArrayList;
import java.util.List;

import net.ihe.gazelle.proxy.netty.ChannelType;
import net.ihe.gazelle.proxy.netty.ConnectionConfigSimple;

import org.jboss.netty.channel.ChannelHandler;

public class ConnectionConfigSimpleTls<A, B> extends ConnectionConfigSimple<A, B> {

	private TlsConfig tlsConfig;

	public ConnectionConfigSimpleTls(int localPort, String remoteHost, int remotePort, ChannelType channelType,
			TlsConfig tlsConfig) {
		super(localPort, remoteHost, remotePort, channelType);
		this.tlsConfig = tlsConfig;
	}

	@Override
	public List<ChannelHandler> getRequestConnectionHandlers() {
		List<ChannelHandler> result = new ArrayList<ChannelHandler>();
		result.addAll(tlsConfig.getServerChannelHandlers());
		result.addAll(super.getRequestConnectionHandlers());
		return result;
	}

	@Override
	public List<ChannelHandler> getResponseConnectionHandlers() {
		List<ChannelHandler> result = new ArrayList<ChannelHandler>();
		result.addAll(tlsConfig.getClientChannelHandlers());
		result.addAll(super.getResponseConnectionHandlers());
		return result;
	}
}
