package net.ihe.gazelle.proxy.netty.channel;

import java.net.InetSocketAddress;
import java.net.SocketAddress;

import net.ihe.gazelle.proxy.netty.Proxy;

import org.apache.log4j.Logger;
import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.channel.MessageEvent;
import org.jboss.netty.channel.SimpleChannelUpstreamHandler;

public class ProxyLoggerRequest<REQU, RESP> extends SimpleChannelUpstreamHandler {

	private Proxy<REQU, RESP> proxy;
	private ProxyHandler matchingHandler;

	private static Logger log = Logger.getLogger(ProxyLoggerRequest.class);

	public ProxyLoggerRequest(Proxy<REQU, RESP> proxy, ProxyHandler matchingHandler) {
		super();
		this.proxy = proxy;
		this.matchingHandler = matchingHandler;
	}

	@Override
	public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) throws Exception {
		final Object message = e.getMessage();
		String fromIp = null;
		int fromPort = 0;
		SocketAddress remoteAddress = e.getRemoteAddress();
		if (remoteAddress instanceof InetSocketAddress) {
			InetSocketAddress inetSocketAddress = (InetSocketAddress) remoteAddress;
			fromIp = inetSocketAddress.getHostName();
			fromPort = inetSocketAddress.getPort();
		}
		try {
			final String fromIpFinal = fromIp;
			final int fromPortFinal = fromPort;
			new Thread(new Runnable() {
				public void run() {
					proxy.handleMessage(message, ProxySide.REQUEST, fromIpFinal, fromPortFinal,
							matchingHandler.getRequestChannel());
				}
			}).start();
		} catch (Throwable t) {
			log.error("Fail to handle request", t);
		}
	}
}
