package net.ihe.gazelle.proxy.netty.channel;

import net.ihe.gazelle.proxy.netty.Proxy;

import org.apache.log4j.Logger;
import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.channel.MessageEvent;
import org.jboss.netty.channel.SimpleChannelUpstreamHandler;

public class ProxyLoggerResponse<REQU, RESP> extends SimpleChannelUpstreamHandler {

	private Proxy<REQU, RESP> proxy;
	private ProxyHandler matchingHandler;

	private static Logger log = Logger.getLogger(ProxyLoggerResponse.class);

	private String requesterIp;
	private int requesterPort;

	public ProxyLoggerResponse(Proxy<REQU, RESP> proxy, ProxyHandler matchingHandler, String requesterIp,
			int requesterPort) {
		super();
		this.proxy = proxy;
		this.requesterIp = requesterIp;
		this.requesterPort = requesterPort;
		this.matchingHandler = matchingHandler;
	}

	@Override
	public void messageReceived(ChannelHandlerContext ctx, MessageEvent e) throws Exception {
		final Object message = e.getMessage();
		try {
			new Thread(new Runnable() {
				public void run() {
					proxy.handleMessage(message, ProxySide.RESPONSE, requesterIp, requesterPort,
							matchingHandler.getRequestChannel());
				}
			}).start();
		} catch (Throwable t) {
			log.error("Fail to handle response", t);
		}
	}
}
