package net.ihe.gazelle.proxy.netty.channel;

import org.jboss.netty.channel.Channel;
import org.jboss.netty.channel.ChannelHandlerContext;
import org.jboss.netty.channel.ChannelStateEvent;

/**
 * The Class ProxyOutboundHandler.<br />
 * Process data to real server, all work is done in ProxyHandler.
 */
public class ProxyOutboundHandler extends ProxyHandler {

	private ProxyInboundHandler proxyInboundHandler = null;

	ProxyOutboundHandler(Channel inboundChannel, ProxyInboundHandler proxyInboundHandler) {
		this.proxiedChannel = inboundChannel;
		this.requestChannel = inboundChannel;
		this.proxyInboundHandler = proxyInboundHandler;
	}

	@Override
	public void channelConnected(ChannelHandlerContext ctx, ChannelStateEvent e) throws Exception {
		if (proxyInboundHandler != null) {
			proxyInboundHandler.onChannelOpen();
		}
	}

}
