package net.ihe.gazelle.proxy.netty.protocols.syslog;

import java.util.ArrayList;
import java.util.List;

import net.ihe.gazelle.proxy.netty.ConnectionConfig;
import net.ihe.gazelle.proxy.netty.Proxy;
import net.ihe.gazelle.proxy.netty.ProxyEventListener;

import org.jboss.netty.buffer.ChannelBuffer;
import org.jboss.netty.buffer.ChannelBuffers;
import org.jboss.netty.channel.ChannelHandler;
import org.jboss.netty.handler.codec.frame.DelimiterBasedFrameDecoder;
import org.jboss.netty.util.CharsetUtil;

public class SyslogProxy extends Proxy<String, String> {

	public SyslogProxy(ProxyEventListener<String, String> proxyEventListener,
			ConnectionConfig<String, String> connectionConfig) {
		super(proxyEventListener, connectionConfig);
	}

	public List<ChannelHandler> getRequestDecoderChannels() {
		List<ChannelHandler> channels = new ArrayList<ChannelHandler>();

		// Decode syslog messages
		channels.add(new DelimiterBasedFrameDecoder(1024 * 1024, getSyslogDelimiter()));

		return channels;
	}

	public static ChannelBuffer[] getSyslogDelimiter() {
		return new ChannelBuffer[] { ChannelBuffers.wrappedBuffer("auditmessage".getBytes(CharsetUtil.UTF_8)) };
	}

	public List<ChannelHandler> getResponseDecoderChannels() {
		return getRequestDecoderChannels();
	}

	@Override
	public String handleRequest(Object message) {
		if (message instanceof ChannelBuffer) {
			ChannelBuffer cb = (ChannelBuffer) message;
			String result = cb.toString(CharsetUtil.UTF_8);
			return result;
		}
		return null;
	}

	@Override
	public String handleResponse(Object message) {
		return handleRequest(message);
	}

}
