package net.ihe.gazelle.proxy.netty;

import java.io.InputStream;

import jp.digitalsensation.ihej.transactionmonitor.dicom.messageexchange.DimseMessage;
import net.ihe.gazelle.proxy.netty.basictls.ConnectionConfigSimpleTls;
import net.ihe.gazelle.proxy.netty.basictls.TlsConfig;
import net.ihe.gazelle.proxy.netty.basictls.TlsCredentials;
import net.ihe.gazelle.proxy.netty.protocols.dicom.DicomProxy;
import net.ihe.gazelle.proxy.netty.protocols.http.HttpProxy;
import net.ihe.gazelle.proxy.netty.tools.DicomEventListenerSimple;
import net.ihe.gazelle.proxy.netty.tools.HttpEventListenerSimple;

import org.jboss.netty.handler.codec.http.HttpMessage;

public class App {
	public static void main(String[] args) throws Exception {
		// testHttpsConnection();

		// startHTTPProxyBasic(10000);
		// startHTTPProxyTLSClient1(10001);
		// startHTTPProxyTLSClient2(10002);
		startHTTPProxyTLSServer(10003);

		final ProxyEventListener<DimseMessage, DimseMessage> dicomProxyEvent = new DicomEventListenerSimple(System.out);
		DicomProxy dicomProxy = new DicomProxy(dicomProxyEvent, new ConnectionConfigSimple<DimseMessage, DimseMessage>(
				10012, "jumbo-4.irisa.fr", 10012, ChannelType.DICOM), null);
		dicomProxy.setStorageFolder("/tmp/dicom");
		dicomProxy.start();

		/*

		final ProxyEventListener<HttpRequest, HttpResponse> httpProxyEvent = new HttpEventListenerSimple(System.out);
		HttpProxy httpProxy = new HttpProxy(httpProxyEvent, 8080, "jumbo-4.irisa.fr", 8080, null);
		httpProxy.start();
		*/

		// final ProxyEventListener<String, String> hl7ProxyEvent = new
		// HL7EventListenerSimple(System.out);
		// HL7Proxy hl7Proxy = new HL7Proxy(hl7ProxyEvent, 10013, "127.0.0.1",
		// 10014, null);
		// hl7Proxy.start();

	}

	private static void startHTTPProxyTLSServer(int port) {
		HttpEventListenerSimple eventListener = new HttpEventListenerSimple(System.out);
		TlsConfig tlsConfig = new TlsConfig(new TlsCredentials(getStream("/435.p12"), "password".toCharArray()), false,
				null);
		HttpProxy httpProxy = new HttpProxy(eventListener, new ConnectionConfigSimpleTls<HttpMessage, HttpMessage>(
				port, "www.google.fr", 80, ChannelType.HTTP, tlsConfig));
		httpProxy.start();
	}

	private static InputStream getStream(String string) {
		return App.class.getResourceAsStream(string);
	}

	private static void startHTTPProxyTLSClient1(int port) {
		HttpEventListenerSimple eventListener = new HttpEventListenerSimple(System.out);
		TlsConfig tlsConfig = new TlsConfig(null, true, new TlsCredentials(getStream("/437.p12"),
				"password".toCharArray()));
		HttpProxy httpProxy = new HttpProxy(eventListener, new ConnectionConfigSimpleTls<HttpMessage, HttpMessage>(
				port, "gazelle.ihe.net", 443, ChannelType.HTTP, tlsConfig));
		httpProxy.start();
	}

	private static void startHTTPProxyTLSClient2(int port) {
		HttpEventListenerSimple eventListener = new HttpEventListenerSimple(System.out);
		TlsConfig tlsConfig = new TlsConfig(null, true, null);
		HttpProxy httpProxy = new HttpProxy(eventListener, new ConnectionConfigSimpleTls<HttpMessage, HttpMessage>(
				port, "www.google.fr", 443, ChannelType.HTTP, tlsConfig));
		httpProxy.start();
	}

	private static void startHTTPProxyBasic(int port) {
		HttpEventListenerSimple eventListener = new HttpEventListenerSimple(System.out);
		HttpProxy httpProxy = new HttpProxy(eventListener, new ConnectionConfigSimple<HttpMessage, HttpMessage>(port,
				"www.google.fr", 80, ChannelType.HTTP));
		httpProxy.start();
	}
}
